/*
Simple library for sound volume manipulation by unknown author
received long time ago from some of FIDONet users. :)
Small modifications by Giordano Bruno (GiordanoFilippoBruno at domain gmail.com)
*/

#ifndef VOLUME_H_INCLUDED
#define VOLUME_H_INCLUDED

typedef int (*ENUMDEVICESFUNC)(DWORD type, MIXERCAPS* lpmxcaps, MIXERLINE* lpmxl, DWORD dwUserValue);
#define TYPE_MIXER 1
#define TYPE_LINEDESTINATION 2
#define TYPE_LINESOURCE 3

class CVolume
{
// Construction
public:
	CVolume();
	~CVolume();
	BOOL Open(HWND Window, DWORD Line);	//TRUE - if Ok, FALSE - if error
										//Line -   
	void Close();

	HMIXER hmx;
	MMRESULT mmr;
	MIXERLINE mxl;
	MIXERLINECONTROLS mxlcs;
	MIXERCONTROL mxc;
	MIXERCONTROLDETAILS mxcd;
	MIXERCONTROLDETAILS_UNSIGNED* lpmxcdu;
	MIXERCONTROLDETAILS_UNSIGNED* lpsafeballance;
	DWORD detailssize;
	int maxi, ballancemaxi;
	DWORD m_MaxVolume, m_LastVolume, m_MinBallanceVolume, m_BallanceVolume;

	DWORD m_CurrentLine,m_SelectedLine,m_SelectedLineId,m_SelectedMixer;

	DWORD GetVolume();
	void SetVolume(DWORD Volume);
	static void EnumDevices(ENUMDEVICESFUNC EnumFunc, DWORD dwUserValue);
	static int EnumProc(DWORD type, MIXERCAPS* lpmxcaps, MIXERLINE* lpmxl, DWORD dwUserValue);
};

#endif
